diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/CMakeLists.txt ns-3.36/src/mobility/CMakeLists.txt
--- ns-3.35/src/mobility/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mobility/CMakeLists.txt	2022-04-30 18:23:58.078734600 -0700
@@ -0,0 +1,55 @@
+build_lib(
+  LIBNAME mobility
+  SOURCE_FILES
+    helper/group-mobility-helper.cc
+    helper/mobility-helper.cc
+    helper/ns2-mobility-helper.cc
+    model/box.cc
+    model/constant-acceleration-mobility-model.cc
+    model/constant-position-mobility-model.cc
+    model/constant-velocity-helper.cc
+    model/constant-velocity-mobility-model.cc
+    model/gauss-markov-mobility-model.cc
+    model/geographic-positions.cc
+    model/hierarchical-mobility-model.cc
+    model/mobility-model.cc
+    model/position-allocator.cc
+    model/random-direction-2d-mobility-model.cc
+    model/random-walk-2d-mobility-model.cc
+    model/random-waypoint-mobility-model.cc
+    model/rectangle.cc
+    model/steady-state-random-waypoint-mobility-model.cc
+    model/waypoint-mobility-model.cc
+    model/waypoint.cc
+  HEADER_FILES
+    helper/group-mobility-helper.h
+    helper/mobility-helper.h
+    helper/ns2-mobility-helper.h
+    model/box.h
+    model/constant-acceleration-mobility-model.h
+    model/constant-position-mobility-model.h
+    model/constant-velocity-helper.h
+    model/constant-velocity-mobility-model.h
+    model/gauss-markov-mobility-model.h
+    model/geographic-positions.h
+    model/hierarchical-mobility-model.h
+    model/mobility-model.h
+    model/position-allocator.h
+    model/random-direction-2d-mobility-model.h
+    model/random-walk-2d-mobility-model.h
+    model/random-waypoint-mobility-model.h
+    model/rectangle.h
+    model/steady-state-random-waypoint-mobility-model.h
+    model/waypoint-mobility-model.h
+    model/waypoint.h
+  LIBRARIES_TO_LINK ${libnetwork}
+  TEST_SOURCES
+    test/box-line-intersection-test.cc
+    test/geo-to-cartesian-test.cc
+    test/mobility-test-suite.cc
+    test/mobility-trace-test-suite.cc
+    test/ns2-mobility-helper-test-suite.cc
+    test/rand-cart-around-geo-test.cc
+    test/steady-state-random-waypoint-mobility-model-test.cc
+    test/waypoint-mobility-model-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/examples/bonnmotion-ns2-example.cc ns-3.36/src/mobility/examples/bonnmotion-ns2-example.cc
--- ns-3.35/src/mobility/examples/bonnmotion-ns2-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/examples/bonnmotion-ns2-example.cc	2022-04-30 18:23:58.082734600 -0700
@@ -37,7 +37,7 @@
  *
  * Finally, note that you can visualize this program using the pyviz
  * visualizer:
- *  ./waf --run bonnmotion-ns2-example --vis
+ *  ./ns3 run bonnmotion-ns2-example --vis
  */
 
 #include "ns3/core-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/examples/CMakeLists.txt ns-3.36/src/mobility/examples/CMakeLists.txt
--- ns-3.35/src/mobility/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mobility/examples/CMakeLists.txt	2022-04-30 18:23:58.082734600 -0700
@@ -0,0 +1,42 @@
+set(base_examples
+    bonnmotion-ns2-example
+    main-random-topology
+    main-random-walk
+    ns2-mobility-trace
+)
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK ${libcore}
+                      ${libmobility}
+  )
+endforeach()
+
+build_lib_example(
+  NAME main-grid-topology
+  SOURCE_FILES main-grid-topology.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libnetwork}
+)
+
+build_lib_example(
+  NAME mobility-trace-example
+  SOURCE_FILES mobility-trace-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libnetwork}
+)
+
+build_lib_example(
+  NAME reference-point-group-mobility-example
+  SOURCE_FILES reference-point-group-mobility-example.cc
+  LIBRARIES_TO_LINK ${libnetwork}
+                    ${libmobility}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/examples/ns2-mobility-trace.cc ns-3.36/src/mobility/examples/ns2-mobility-trace.cc
--- ns-3.35/src/mobility/examples/ns2-mobility-trace.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/examples/ns2-mobility-trace.cc	2022-04-30 18:23:58.082734600 -0700
@@ -36,7 +36,7 @@
  *
  * Usage of ns2-mobility-trace:
  *
- *  ./waf --run "ns2-mobility-trace \
+ *  ./ns3 run "ns2-mobility-trace \
  *        --traceFile=src/mobility/examples/default.ns_movements
  *        --nodeNum=2  --duration=100.0 --logFile=ns2-mobility-trace.log"
  *
@@ -94,7 +94,7 @@
   if (traceFile.empty () || nodeNum <= 0 || duration <= 0 || logFile.empty ())
     {
       std::cout << "Usage of " << argv[0] << " :\n\n"
-      "./waf --run \"ns2-mobility-trace"
+      "./ns3 run \"ns2-mobility-trace"
       " --traceFile=src/mobility/examples/default.ns_movements"
       " --nodeNum=2 --duration=100.0 --logFile=ns2-mob.log\" \n\n"
       "NOTE: ns2-traces-file could be an absolute or relative path. You could use the file default.ns_movements\n"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/helper/mobility-helper.h ns-3.36/src/mobility/helper/mobility-helper.h
--- ns-3.35/src/mobility/helper/mobility-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/helper/mobility-helper.h	2022-04-30 18:23:58.082734600 -0700
@@ -26,7 +26,7 @@
 #include "ns3/attribute.h"
 #include "ns3/output-stream-wrapper.h"
 #include "ns3/position-allocator.h"
-#include "node-container.h"
+#include "ns3/node-container.h"
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/helper/ns2-mobility-helper.cc ns-3.36/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.35/src/mobility/helper/ns2-mobility-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/helper/ns2-mobility-helper.cc	2022-04-30 18:23:58.082734600 -0700
@@ -42,7 +42,6 @@
 #include <sstream>
 #include <map>
 #include "ns3/log.h"
-#include "ns3/unused.h"
 #include "ns3/simulator.h"
 #include "ns3/node-list.h"
 #include "ns3/node.h"
@@ -595,8 +594,7 @@
 IsNumber (const std::string& s)
 {
   char *endp;
-  double v = strtod (s.c_str (), &endp); // declared with warn_unused_result
-  NS_UNUSED (v); // suppress "set but not used" compiler warning
+  [[maybe_unused]] double v = strtod (s.c_str (), &endp);
   return endp == s.c_str () + s.size ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/model/steady-state-random-waypoint-mobility-model.cc ns-3.36/src/mobility/model/steady-state-random-waypoint-mobility-model.cc
--- ns-3.35/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2022-04-30 18:23:58.082734600 -0700
@@ -184,6 +184,7 @@
   else // node initially moving
     {
       double x1, x2, y1, y2;
+      x1 = x2 = y1 = y2 = 0;
       double r = 0;
       double u1 = 1;
       while (u1 >= r)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mobility/test/mobility-test-suite.cc ns-3.36/src/mobility/test/mobility-test-suite.cc
--- ns-3.35/src/mobility/test/mobility-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mobility/test/mobility-test-suite.cc	2022-04-30 18:23:58.082734600 -0700
@@ -79,14 +79,14 @@
 WaypointLazyNotifyFalse::TestXPosition (double expectedXPos)
 {
   Vector pos = m_mob->GetPosition ();
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (pos.x, expectedXPos, 0.001, "Position not equal", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (pos.x, expectedXPos, 0.001, "Position not equal");
 }
 
 void
 WaypointLazyNotifyFalse::CourseChangeCallback (std::string path, Ptr<const MobilityModel> model)
 {
   // All waypoints (at 10 second intervals) should trigger a course change
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (m_courseChanges * 10.0, Simulator::Now ().GetSeconds (), 0.001, "Course change not notified correctly", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (m_courseChanges * 10.0, Simulator::Now ().GetSeconds (), 0.001, "Course change not notified correctly");
   m_courseChanges++;
 }
 
@@ -151,7 +151,7 @@
 WaypointLazyNotifyTrue::TestXPosition (double expectedXPos)
 {
   Vector pos = m_mob->GetPosition ();
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (pos.x, expectedXPos, 0.001, "Position not equal", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (pos.x, expectedXPos, 0.001, "Position not equal");
 }
 
 void
@@ -159,7 +159,7 @@
 {
   // This should trigger at time 15 only, since that is the first time that
   // position is updated due to LazyNotify
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (15, Simulator::Now ().GetSeconds (), 0.001, "Course change not notified correctly", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (15, Simulator::Now ().GetSeconds (), 0.001, "Course change not notified correctly");
 }
 
 void
@@ -227,7 +227,7 @@
 WaypointInitialPositionIsWaypoint::TestXPosition (Ptr<const WaypointMobilityModel> model, double expectedXPos)
 {
   Vector pos = model->GetPosition ();
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (pos.x, expectedXPos, 0.001, "Position not equal", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (pos.x, expectedXPos, 0.001, "Position not equal");
 }
 
 void
@@ -356,7 +356,7 @@
 WaypointMobilityModelViaHelper::TestXPosition (Ptr<const WaypointMobilityModel> mob, double expectedXPos)
 {
   Vector pos = mob->GetPosition ();
-  NS_TEST_EXPECT_MSG_EQ_TOL_INTERNAL (pos.x, expectedXPos, 0.001, "Position not equal", __FILE__, __LINE__);
+  NS_TEST_EXPECT_MSG_EQ_TOL (pos.x, expectedXPos, 0.001, "Position not equal");
 }
 
 // WaypointMobilityModel tests using the helper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/CMakeLists.txt ns-3.36/src/mpi/CMakeLists.txt
--- ns-3.35/src/mpi/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mpi/CMakeLists.txt	2022-04-30 18:23:58.086734500 -0700
@@ -0,0 +1,31 @@
+include_directories(${MPI_CXX_INCLUDE_DIRS})
+
+set(example_as_test_suite)
+if(${ENABLE_EXAMPLES})
+  set(example_as_test_suite
+      test/mpi-test-suite.cc
+  )
+endif()
+
+build_lib(
+  LIBNAME mpi
+  SOURCE_FILES
+    model/distributed-simulator-impl.cc
+    model/granted-time-window-mpi-interface.cc
+    model/mpi-interface.cc
+    model/mpi-receiver.cc
+    model/null-message-mpi-interface.cc
+    model/null-message-simulator-impl.cc
+    model/parallel-communication-interface.h
+    model/remote-channel-bundle-manager.cc
+    model/remote-channel-bundle.cc
+  HEADER_FILES
+    model/mpi-interface.h
+    model/mpi-receiver.h
+    model/parallel-communication-interface.h
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libnetwork}
+    ${MPI_CXX_LIBRARIES}
+  TEST_SOURCES ${example_as_test_suite}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/examples/CMakeLists.txt ns-3.36/src/mpi/examples/CMakeLists.txt
--- ns-3.35/src/mpi/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mpi/examples/CMakeLists.txt	2022-04-30 18:23:58.090734700 -0700
@@ -0,0 +1,40 @@
+include_directories(${MPI_CXX_INCLUDE_DIRS})
+link_libraries(${MPI_CXX_LIBRARIES})
+
+set(base_examples
+    simple-distributed
+    simple-distributed-mpi-comm
+    nms-p2p-nix-distributed
+    simple-distributed-empty-node
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+                 mpi-test-fixtures.cc
+    LIBRARIES_TO_LINK
+      ${libmpi}
+      ${libpoint-to-point}
+      ${libinternet}
+      ${libnix-vector-routing}
+      ${libapplications}
+  )
+endforeach()
+
+build_lib_example(
+  NAME third-distributed
+  SOURCE_FILES third-distributed.cc
+               mpi-test-fixtures.cc
+  LIBRARIES_TO_LINK
+    ${libmpi}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libmobility}
+    ${libwifi}
+    ${libcsma}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/examples/mpi-test-fixtures.h ns-3.36/src/mpi/examples/mpi-test-fixtures.h
--- ns-3.35/src/mpi/examples/mpi-test-fixtures.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/examples/mpi-test-fixtures.h	2022-04-30 18:23:58.090734700 -0700
@@ -47,6 +47,8 @@
 
   
 /**
+ * \ingroup mpi
+ * 
  * Write to std::cout only from rank 0.
  * Number line for sorting output of parallel runs.
  *
@@ -64,6 +66,14 @@
       }                                                                                \
   while (false)
   
+/**
+ * \ingroup mpi
+ * 
+ * Append to std::cout only from rank 0.
+ * Number line for sorting output of parallel runs.
+ *
+ * \param x The output operators.
+ */
 #define RANK0COUTAPPEND(x)                      \
   do                                            \
     if (SinkTracer::GetWorldRank () == 0)       \
@@ -72,13 +82,17 @@
       }                                         \
   while (false)
 
+/**
+ * \ingroup mpi
+ * 
+ * Collects data about incoming packets.
+ */
 class SinkTracer
 {
 
 public:
   /**
-   * PacketSink receive trace callback.
-   * \copydetails ns3::Packet::TwoAddressTracedCallback
+   * PacketSink Init.
    */
   static void Init (void);
 
@@ -93,6 +107,8 @@
   /**
    * Verify the sink trace count observed matches the expected count.
    * Prints message to std::cout indicating success or fail.
+   * 
+   * \param expectedCount Expected number of packet received.
    */
   static void Verify (unsigned long expectedCount);
   
@@ -125,8 +141,8 @@
   }
 
   /**
-   * Get current line count and increment.
-   *
+   * Get current line count and increment it.
+   * \return the line count.
    */
   static int GetLineCount (void)
   {
@@ -134,10 +150,10 @@
   }
 
 private:
-  static unsigned long m_sinkCount; /*< Running sum of number of SinkTrace calls observed */
-  static unsigned long m_line; /*< Current output line number for ordering output */
-  static int m_worldRank; /*< MPI CommWorld rank */
-  static int m_worldSize; /*< MPI CommWorld size */
+  static unsigned long m_sinkCount; //!< Running sum of number of SinkTrace calls observed
+  static unsigned long m_line; //!< Current output line number for ordering output
+  static int m_worldRank; //!< MPI CommWorld rank
+  static int m_worldSize; //!< MPI CommWorld size
 };
 
 }  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/examples/simple-distributed-mpi-comm.cc ns-3.36/src/mpi/examples/simple-distributed-mpi-comm.cc
--- ns-3.35/src/mpi/examples/simple-distributed-mpi-comm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/examples/simple-distributed-mpi-comm.cc	2022-04-30 18:23:58.090734700 -0700
@@ -77,16 +77,20 @@
 
 NS_LOG_COMPONENT_DEFINE ("SimpleDistributedMpiComm");
 
-// Tag for whether this rank should go into a new communicator
-// ns-3 ranks will have color == 1.
+/**
+ * Tag for whether this rank should go into a new communicator
+ * ns-3 ranks will have color == 1.
+ * @{
+ */
 const int NS_COLOR = 1;
 const int NOT_NS_COLOR = NS_COLOR + 1;
+/** @} */
 
 /**
  * Report my rank, in both MPI_COMM_WORLD and the split communicator.
  *
  * \param [in] color My role, either ns-3 rank or other rank.
- * \param [in] spitComm The split communicator.
+ * \param [in] splitComm The split communicator.
  */
 void
 ReportRank (int color, MPI_Comm splitComm)
@@ -123,7 +127,7 @@
   bool testing = false;
 
   // Parse command line
-  CommandLine cmd;
+  CommandLine cmd(__FILE__);
   cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization (instead of granted time window)", nullmsg);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/examples/third-distributed.cc ns-3.36/src/mpi/examples/third-distributed.cc
--- ns-3.35/src/mpi/examples/third-distributed.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/examples/third-distributed.cc	2022-04-30 18:23:58.090734700 -0700
@@ -163,22 +163,20 @@
   YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
 
-  WifiHelper wifi;
-  wifi.SetRemoteStationManager ("ns3::AarfWifiManager");
-
   WifiMacHelper mac;
   Ssid ssid = Ssid ("ns-3-ssid");
+
+  WifiHelper wifi;
+
+  NetDeviceContainer staDevices;
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid),
                "ActiveProbing", BooleanValue (false));
-
-  NetDeviceContainer staDevices;
   staDevices = wifi.Install (phy, mac, wifiStaNodes);
 
+  NetDeviceContainer apDevices;
   mac.SetType ("ns3::ApWifiMac",
                "Ssid", SsidValue (ssid));
-
-  NetDeviceContainer apDevices;
   apDevices = wifi.Install (phy, mac, wifiApNode);
 
   MobilityHelper mobility;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/model/distributed-simulator-impl.cc ns-3.36/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.35/src/mpi/model/distributed-simulator-impl.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/model/distributed-simulator-impl.cc	2022-04-30 18:23:58.090734700 -0700
@@ -110,13 +110,8 @@
 
   m_stop = false;
   m_globalFinished = false;
-  // uids are allocated from 4.
-  // uid 0 is "invalid" events
-  // uid 1 is "now" events
-  // uid 2 is "destroy" events
-  m_uid = 4;
-  // before ::Run is entered, the m_currentUid will be zero
-  m_currentUid = 0;
+  m_uid = EventId::UID::VALID;
+  m_currentUid = EventId::UID::INVALID;
   m_currentTs = 0;
   m_currentContext = Simulator::NO_CONTEXT;
   m_unscheduledEvents = 0;
@@ -314,6 +309,9 @@
 
   Scheduler::Event next = m_events->RemoveNext ();
 
+  PreEventHook (EventId (next.impl, next.key.m_ts, 
+                         next.key.m_context, next.key.m_uid));
+
   NS_ASSERT (next.key.m_ts >= m_currentTs);
   m_unscheduledEvents--;
   m_eventCount++;
@@ -508,16 +506,7 @@
 DistributedSimulatorImpl::ScheduleNow (EventImpl *event)
 {
   NS_LOG_FUNCTION (this << event);
-
-  Scheduler::Event ev;
-  ev.impl = event;
-  ev.key.m_ts = m_currentTs;
-  ev.key.m_context = GetContext ();
-  ev.key.m_uid = m_uid;
-  m_uid++;
-  m_unscheduledEvents++;
-  m_events->Insert (ev);
-  return EventId (event, ev.key.m_ts, ev.key.m_context, ev.key.m_uid);
+  return Schedule (Time (0), event);
 }
 
 EventId
@@ -553,7 +542,7 @@
 void
 DistributedSimulatorImpl::Remove (const EventId &id)
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       // destroy events.
       for (DestroyEvents::iterator i = m_destroyEvents.begin (); i != m_destroyEvents.end (); i++)
@@ -595,7 +584,7 @@
 bool
 DistributedSimulatorImpl::IsExpired (const EventId &id) const
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       if (id.PeekEventImpl () == 0
           || id.PeekEventImpl ()->IsCancelled ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/model/mpi-interface.h ns-3.36/src/mpi/model/mpi-interface.h
--- ns-3.35/src/mpi/model/mpi-interface.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/model/mpi-interface.h	2022-04-30 18:23:58.090734700 -0700
@@ -35,7 +35,12 @@
 namespace ns3 {
 /**
  * \defgroup mpi MPI Distributed Simulation
- *
+ */
+
+/**
+ * \ingroup mpi
+ * \ingroup tests
+ * \defgroup mpi-tests MPI Distributed Simulation tests
  */
 
 class ParallelCommunicationInterface;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/model/null-message-simulator-impl.cc ns-3.36/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.35/src/mpi/model/null-message-simulator-impl.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/model/null-message-simulator-impl.cc	2022-04-30 18:23:58.090734700 -0700
@@ -79,13 +79,8 @@
   m_systemCount = MpiInterface::GetSize ();
 
   m_stop = false;
-  // uids are allocated from 4.
-  // uid 0 is "invalid" events
-  // uid 1 is "now" events
-  // uid 2 is "destroy" events
-  m_uid = 4;
-  // before ::Run is entered, the m_currentUid will be zero
-  m_currentUid = 0;
+  m_uid = EventId::UID::VALID;
+  m_currentUid = EventId::UID::INVALID;
   m_currentTs = 0;
   m_currentContext = Simulator::NO_CONTEXT;
   m_unscheduledEvents = 0;
@@ -235,6 +230,9 @@
 
   Scheduler::Event next = m_events->RemoveNext ();
 
+  PreEventHook (EventId (next.impl, next.key.m_ts, 
+                         next.key.m_context, next.key.m_uid));
+
   NS_ASSERT (next.key.m_ts >= m_currentTs);
   m_unscheduledEvents--;
   m_eventCount++;
@@ -438,16 +436,7 @@
 NullMessageSimulatorImpl::ScheduleNow (EventImpl *event)
 {
   NS_LOG_FUNCTION (this << event);
-
-  Scheduler::Event ev;
-  ev.impl = event;
-  ev.key.m_ts = m_currentTs;
-  ev.key.m_context = GetContext ();
-  ev.key.m_uid = m_uid;
-  m_uid++;
-  m_unscheduledEvents++;
-  m_events->Insert (ev);
-  return EventId (event, ev.key.m_ts, ev.key.m_context, ev.key.m_uid);
+  return Schedule (Time (0), event);
 }
 
 EventId
@@ -483,7 +472,7 @@
 void
 NullMessageSimulatorImpl::Remove (const EventId &id)
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       // destroy events.
       for (DestroyEvents::iterator i = m_destroyEvents.begin (); i != m_destroyEvents.end (); i++)
@@ -525,7 +514,7 @@
 bool
 NullMessageSimulatorImpl::IsExpired (const EventId &id) const
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       if (id.PeekEventImpl () == 0
           || id.PeekEventImpl ()->IsCancelled ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/model/null-message-simulator-impl.h ns-3.36/src/mpi/model/null-message-simulator-impl.h
--- ns-3.35/src/mpi/model/null-message-simulator-impl.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/model/null-message-simulator-impl.h	2022-04-30 18:23:58.090734700 -0700
@@ -21,7 +21,7 @@
 /**
  * \file
  * \ingroup mpi
- * Declaration of class ns3::NullMessageSimulatorImpl. 
+ * Declaration of class ns3::NullMessageSimulatorImpl.
  */
 
 
@@ -98,7 +98,7 @@
   friend class RemoteChannelBundleManager;
 
   /**
-   * Non blocking receive of pending messages.  
+   * Non blocking receive of pending messages.
    */
   void HandleArrivingMessagesNonBlocking (void);
 
@@ -134,6 +134,7 @@
    * Get the current SafeTime; the maximum time that events can
    * be processed based on information received from neighboring
    * MPI tasks.
+   * \return the current SafeTime
    */
   Time GetSafeTime (void);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/test/mpi-example-comm-2-init.reflog ns-3.36/src/mpi/test/mpi-example-comm-2-init.reflog
--- ns-3.35/src/mpi/test/mpi-example-comm-2-init.reflog	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/test/mpi-example-comm-2-init.reflog	2022-04-30 18:23:58.090734700 -0700
@@ -1,4 +1,4 @@
-TEST : 00000 : 
+TEST : 00000 : simple-distributed-mpi-comm
 TEST : 00001 : 
 TEST : 00002 : Configuration:
 TEST : 00003 : Routing:           nix-vector
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/test/mpi-example-comm-2.reflog ns-3.36/src/mpi/test/mpi-example-comm-2.reflog
--- ns-3.35/src/mpi/test/mpi-example-comm-2.reflog	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/test/mpi-example-comm-2.reflog	2022-04-30 18:23:58.090734700 -0700
@@ -1,4 +1,4 @@
-TEST : 00000 : 
+TEST : 00000 : simple-distributed-mpi-comm
 TEST : 00001 : 
 TEST : 00002 : Configuration:
 TEST : 00003 : Routing:           nix-vector
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/test/mpi-example-comm-3-init.reflog ns-3.36/src/mpi/test/mpi-example-comm-3-init.reflog
--- ns-3.35/src/mpi/test/mpi-example-comm-3-init.reflog	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/test/mpi-example-comm-3-init.reflog	2022-04-30 18:23:58.090734700 -0700
@@ -1,4 +1,4 @@
-TEST : 00000 : 
+TEST : 00000 : simple-distributed-mpi-comm
 TEST : 00001 : 
 TEST : 00002 : Configuration:
 TEST : 00003 : Routing:           nix-vector
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mpi/test/mpi-test-suite.cc ns-3.36/src/mpi/test/mpi-test-suite.cc
--- ns-3.35/src/mpi/test/mpi-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mpi/test/mpi-test-suite.cc	2022-04-30 18:23:58.090734700 -0700
@@ -25,6 +25,8 @@
 using namespace ns3;
 
 /**
+ * \ingroup mpi-tests
+ * 
  * This version of ns3::ExampleTestCase is specialized for MPI
  * by accepting the number of ranks as a parameter,
  * then building a `--command-template` string which
@@ -94,7 +96,10 @@
   return command;
 }
 
-/** MPI specialization of ns3::ExampleTestSuite. */
+/**
+ * \ingroup mpi-tests
+ * MPI specialization of ns3::ExampleTestSuite.
+ */
 class MpiTestSuite : public TestSuite
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/netanim/bindings/callbacks_list.py ns-3.36/src/netanim/bindings/callbacks_list.py
--- ns-3.35/src/netanim/bindings/callbacks_list.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/netanim/bindings/callbacks_list.py	2022-04-30 18:23:58.090734700 -0700
@@ -10,7 +10,7 @@
     ['void', 'ns3::Ptr<ns3::SpectrumSignalParameters>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage>>>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned short', 'ns3::Ptr<ns3::SpectrumValue>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::DlInfoListElement_s', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::UlInfoListElement_s', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
@@ -21,25 +21,24 @@
     ['void', 'unsigned short', 'unsigned short', 'double', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned short', 'unsigned short', 'double', 'double', 'bool', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::PhyTransmissionStatParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned short', 'const std::vector<int, std::allocator<int> > &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'const std::vector<int, std::allocator<int>> &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned short', 'unsigned short', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Packet>', 'double', 'ns3::UanTxMode', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::UanTxMode', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::RxSignalInfo', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::RxSignalInfo', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool>>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Time', 'WifiPhyState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu> > > >', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int> >, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu>>>>', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int>>, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double>>>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
